/*
 * This code is based on an example provided by Richard Stanford, 
 * a tutorial reader.
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import java.util.*;


public class BuddyList extends JPanel {
    private int newNodeSuffix = 1;
	final DynamicTree treePanel;
	Vector buddyStatusV;
	String nick;
    public BuddyList() 
    {
        //create the components
        treePanel = new DynamicTree();
        setLayout(new BorderLayout());
        treePanel.setPreferredSize(new Dimension(120,300 ));
        add(treePanel, BorderLayout.CENTER);
    }

	void makeRoot()
	{
		String[] buddyStatusA ;
		BuddyStatus buddyStatus;
		for (int i = 0 ; i < buddyStatusV.size() ; i++)
		{
			buddyStatus = (BuddyStatus)buddyStatusV.elementAt(i);
			if (buddyStatus.getBuddyGroup().equals("Buddy"))
			{
				DefaultMutableTreeNode parentNode;
				parentNode = treePanel.addObject(null, buddyStatus);
				buddyStatusV.removeElementAt(i);
				DefaultMutableTreeNode node = makeFamily(parentNode, buddyStatusV);
				if (buddyStatusV.size() > 0)
				{
					i = -1;
				}
			}
		}
	}

	DefaultMutableTreeNode makeFamily(DefaultMutableTreeNode parentNode, Vector buddyStatusV)
	{
	   	p.r(this,"parentNode",parentNode);
    	BuddyStatus parentBuddyStatus=(BuddyStatus)parentNode.getUserObject();
    	p.r(this,"makeFamily",parentBuddyStatus.toString());
    	DefaultMutableTreeNode childNode;
    	for(int i = 0 ; i < buddyStatusV.size() ;i++)
    	{
    		BuddyStatus buddyStatus=(BuddyStatus)buddyStatusV.elementAt(i);
    		String buddyGroup=buddyStatus.getBuddyGroup();
    		
    		if (parentBuddyStatus.toString().equals(buddyGroup))
    		{  
    			childNode = treePanel.addObject(parentNode,buddyStatus);
				p.r(this,"parent", parentNode);
				p.r(this,"child", buddyStatus);
    			buddyStatusV.remove(i);
    			i --;
        		childNode = makeFamily(childNode,buddyStatusV);
        	}
    	}
    	return(parentNode);
	}
			
	public void updateBuddy(String nick,Vector buddyMemoStatusV)//ChatClient  
 	{
 		treePanel.clear();
 		this.nick = nick;
		buddyStatusV = new Vector();
		String[] buddyStatusA ;
		String[] buddyMemoStatusA ;
		BuddyStatus buddyStatus;
		for(int i = 0 ; i < buddyMemoStatusV.size() ; i++)
		{
			buddyStatusA = new String[4];
			buddyMemoStatusA = (String[])buddyMemoStatusV.elementAt(i);
			buddyStatus = new BuddyStatus(buddyMemoStatusA[0], buddyMemoStatusA[1], buddyMemoStatusA[2], buddyMemoStatusA[3]);
			buddyStatusV.addElement(buddyStatus);
		}
		makeRoot();
	}
	
	String getBuddy()
	{
		return treePanel.getBuddy();
	}
	
	String getBuddyGroup()
	{
		return treePanel.getBuddyGroup();
	}

	void removeBuddy()
	{
        TreePath currentSelection = treePanel.tree.getSelectionPath();
        if (currentSelection != null) 
        {
			DefaultMutableTreeNode currentNode = (DefaultMutableTreeNode)(currentSelection.getLastPathComponent());
			System.out.println(currentNode);
			MutableTreeNode parent = (MutableTreeNode)(currentNode.getParent());
			if(currentNode.isLeaf() && parent != null)
            {
				try
				{
					BuddyPersistent buddyPersistent = new BuddyPersistent(nick,parent.toString(),currentNode.toString());
					if(!buddyPersistent.remove())
					{
						System.out.println("Error Occoured in deleting leaf ! ");
					}
				}catch(Exception ex)
				{
					ex.printStackTrace();
				}
				treePanel.removeCurrentNode();
				return;
            }
            else if(currentNode.isLeaf()==false && parent !=null)
            {
            	//ڽĳ    dialogâ .
            	int n = JOptionPane.showConfirmDialog(new JFrame(), "Child nod exist ! . Delete really ?",
                            "<DELETE>", JOptionPane.YES_NO_OPTION);
				if (n == JOptionPane.YES_OPTION) 
				{
				    System.out.println("recursive call start");
					recursiveRemove(currentNode);
					System.out.println("recursive call end");
				    treePanel.removeCurrentNode();
 				} 
				return;
			}
        } 
	}

	public void recursiveRemove(DefaultMutableTreeNode node)
	{	
		//System.out.println("Ѿ 尪 :"+node);
		 DefaultMutableTreeNode child;
		 
		 if(node != null)
		 {	
		 	try
		 	{
		  		System.out.println(node);
		  		BuddyPersistent buddyPersistent;
		  		Enumeration enNode = node.preorderEnumeration();
		  		while(enNode.hasMoreElements())
		  		{
		  			String buddy = enNode.nextElement().toString();
           			buddyPersistent = new BuddyPersistent(nick,buddy);
           			p.r(this,"recursiveRemove",buddy);
					s(1000);
			 		if(!buddyPersistent.remove())
			 		{
			 			System.out.println("Error occured in delete !");
			 		}
		 		}
		 	}catch(Exception ex)
		 	{
		 		ex.printStackTrace();
		 	}
		 }	
		 return;
	}

	
	void addBuddy(String buddy)
	{
    	String parent = getBuddyGroup();
    	BuddyStatus buddyStatus = new BuddyStatus(parent,buddy,"0","0");
        BuddyPersistent buddyPersistent = new BuddyPersistent(nick,parent,buddy);
        if(!buddyPersistent.save())
        {
        	System.out.println("Error : not inserted !");
        }
		treePanel.addObject(buddyStatus);
	}
	static void s(int SLEEP)
	{
		try
		{
			Thread.currentThread().sleep(SLEEP);
		}
		catch(InterruptedException iE)
		{
			iE.printStackTrace();
		}
	}	
}
