import java.awt.*;
import java.awt.event.*;
import java.sql.ResultSet;
import java.util.Vector;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import java.awt.event.ActionListener;

class BuddyRenderer extends DefaultTreeCellRenderer 
{
    ImageIcon onLine_onMsg;
    ImageIcon onLine_offMsg;
    ImageIcon offLine_onMsg;
    ImageIcon offLine_offMsg;

    public BuddyRenderer() {
    	onLine_onMsg 	= new ImageIcon("Icon/gima11.gif");
    	onLine_offMsg 	= new ImageIcon("Icon/gima10.gif");
    	offLine_onMsg 	= new ImageIcon("Icon/gima01.gif");
    	offLine_offMsg 	= new ImageIcon("Icon/gima00.gif");
    }

    public Component getTreeCellRendererComponent(
                        JTree tree,
                        Object value,
                        boolean sel,
                        boolean expanded,
                        boolean leaf,
                        int row,
                        boolean hasFocus) 
   {

		super.getTreeCellRendererComponent(
                        tree, value, sel,
                        expanded, leaf, row,
                        hasFocus);
        if (leaf)
        {
        	switch (valOf(value)) 
        	{
	        	case 0:
	        	{
		            setIcon(offLine_offMsg);
		            setToolTipText("Off Line.");
		            break;
	        	}
	        	case 10:
	        	{
		            setIcon(offLine_onMsg);
		            setToolTipText("Off & Memo");
		            break;
	        	}
	        	case 01:
	        	{
		            setIcon(onLine_offMsg);
		            setToolTipText("On Line");
		            break;
	        	}
	        	case 11:
	        	{
		            setIcon(onLine_onMsg);
		            setToolTipText("On & Memo");
		            break;
	        	}
            } 
        }
        return this;
    }


    protected int valOf(Object value) 
    {
    	p.r(this,"valOf",value.toString());
    	int face = 0;
        DefaultMutableTreeNode node = (DefaultMutableTreeNode)value;
        BuddyStatus buddyStatus = (BuddyStatus)(node.getUserObject());
        if(buddyStatus == null)
        {
        	return 0;
        }
        
        System.out.println("buddyStatus : " + buddyStatus);
        if (buddyStatus.online.equals("1"))
        {	
        	face += 1;
        }
        if (buddyStatus.memo.equals("1"))
        {	
        	face += 10;
        }
        return face;
    }
}
