import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;

public class ChatColor extends WindowAdapter implements ActionListener
{
	Color newColor;
	Client chatClient;
	JFrame colorFrame;
    public ChatColor(Client chatClient) 
    {
        //Set up the banner at the top of the window
        this.chatClient = chatClient;
        colorFrame = new JFrame();
        final JLabel banner = new JLabel("Happy Chatting  ϼ", JLabel.CENTER);
        
        banner.setForeground(Color.yellow);
        banner.setBackground(Color.white);
        banner.setOpaque(true);
        banner.setFont(new Font("SansSerif", Font.BOLD, 16));
        banner.setPreferredSize(new Dimension(50, 30));
        
       	JButton colorForeButton = new JButton("ۻ");
       	JButton colorBackButton = new JButton("");
       	colorForeButton.addActionListener(this);
		colorBackButton.addActionListener(this);

        JPanel bannerPanel = new JPanel(new BorderLayout());
        bannerPanel.add(banner, BorderLayout.CENTER);
        bannerPanel.add(colorForeButton, BorderLayout.EAST);
        bannerPanel.add(colorBackButton, BorderLayout.WEST);
        bannerPanel.setBorder(BorderFactory.createTitledBorder(" ð"));

        //Set up color chooser for setting text color
        final JColorChooser tcc = new JColorChooser(banner.getForeground());
        tcc.getSelectionModel().addChangeListener(
            new ChangeListener() {
                public void stateChanged(ChangeEvent e) {
                    newColor = tcc.getColor();
                    banner.setForeground(newColor);
                }
            }
        );
        tcc.setBorder(BorderFactory.createTitledBorder(
                                             "Choose Chatting Color"));

        //Add the components to the demo frame
        Container contentPane = colorFrame.getContentPane();
        contentPane.add(bannerPanel, BorderLayout.CENTER);
        contentPane.add(tcc, BorderLayout.SOUTH);
        colorFrame.pack();
        colorFrame.setVisible(true);
    }
    
    public void windowClosing(WindowEvent e) 
    {
    	colorFrame.dispose();
   	}
   	
   	public void actionPerformed(ActionEvent aE)
   	{
   		String command = aE.getActionCommand();
   		if(command.equals("ۻ"))
   		{
   			chatClient.setWordColor(newColor);
   			colorFrame.dispose();
   		}
   		if(command.equals(""))
   		{
   			chatClient.setBackWordColor(newColor);
   			colorFrame.dispose();
   		}
   	}
   	
    	
/*
    public static void main(String[] args) 
    {
    	JFrame chatFrame = new JFrame();
        ChatColor chatColor = new ChatColor(chatFrame,"ChatColor Test");
        chatFrame.addWindowListener(chatColor);

        chatFrame.pack();
        chatFrame.setVisible(true);
    }
*/    
}
