// FILE: c:/temp/SMCHATTING/ChatServer.java

//package SMCHATTING;
import java.util.*;
import java.io.*;
import java.net.*;
import java.lang.Thread;
import java.lang.Runnable;



class ChatServer  extends Vector implements Server
{
	int PORT ;	
		
	String title;
	Socket socketToClient;	
	void init() 
	{
		PORT = Integer.parseInt(InitProperty.getInstance().getValue("PORT"));
		ServerSocket masterSocket =(ServerSocket)null; 
		try
		{
			masterSocket = new ServerSocket(PORT);
		}
		
		catch(Exception e)
		{
			System.out.println("\n\n\n Server Error : PORT is in use ...\n\n");
			System.exit(-1);
		}
		System.out.println("\n\n\n  OK !  Server is running ...\n\n");
		serviceStart(masterSocket);
	}
	
	public void service()
	{
	}
	
	void serviceStart(ServerSocket serverMasterSocket)
	{
		while(true)
		{
			Socket socketToClient = (Socket)null;
			try
			{
				socketToClient = serverMasterSocket.accept();
				ServerThread serverThread = new ServerThread(this,socketToClient);
				long curTime = System.currentTimeMillis();
				String threadName = String.valueOf(curTime);
				Thread newClientServer = new Thread(serverThread);
				newClientServer.setName(threadName);
				addElement(new ServerThreadElement(threadName,newClientServer));
				newClientServer.start();
			}
			catch(Exception e)
			{
				try
				{
					socketToClient.close();
					System.out.println("\n\n\n Client Error : thread  Ͽϴ. \n\n");
				}
				catch(IOException ioE)
				{
					System.out.println("\n\n\n Client Error : Ʈ  ֽϴ. \n\n");
				}
			}
		}
	}
	
	public void destroyThread(Thread deadThread)
	{
		String threadName = deadThread.getName();
		
		for(int i = 0 ; i < size() ; i++)
		{
			ServerThreadElement serverThreadElement = (ServerThreadElement)elementAt(i);
			if(serverThreadElement.getName().equals(threadName))
			{
				removeElementAt(i);
			}
		}
	}
	
	public static void main(String args[]) 
	{
		ChatServer chatServer = new ChatServer();
		chatServer.init();
	}
	
} /* end class ChatServer */

class ServerThreadElement 
{
	String threadName;
	Thread serverThreadElement;
	public ServerThreadElement(String threadName,Thread serverThreadElement)
	{
		this.threadName = threadName;
		this.serverThreadElement = serverThreadElement;
	}
	String getName()
	{
		return threadName;
	}
	
}
