// FILE: c:/temp/SMCHATTING/ClientThread.java

//package SMCHATTING;
import java.util.*;
import java.lang.Runnable;
import java.io.*;
import javax.swing.*;
import java.lang.Thread;

class ClientThread implements Runnable 
{
	ObjectInputStream ois;
	Datum datum;
	Client chatClient;
	JLabel msgLabel;
	ChatMsg chatMsg;

	public ClientThread(ObjectInputStream ois, Client chatClient)
	{
		this.ois = ois ;
		this.chatClient = chatClient;
	}
	public void run()
	{
		
//		Thread.currentThread().setName(" ***  ");
		while(true)
		{
			try
			{
				datum = (Datum)(ois.readObject());
				datum.print(); /////  Ұ
				if( ! (datum == null))
				{
					decodeDatum();
					chatClient.resetMessageField();
				}
				else 
				{
					Thread.currentThread().sleep(10);
				}
			}
			catch(Exception e)
			{
				System.out.println(" CLIENT log out !  bye  bye ");
				break;
			}
		}
	}




	void decodeDatum() 
	{
		int sw = datum.getStatus();
		Object info = datum.getInfo();
		switch(sw)
		{
			case Datum.CHAT_ONGOING:
			{
				chatClient.setChatMessage((ChatMsg)info);
				break;
			}
						
			case Datum.CHAT_CLOSE:
			{
				chatClient.setChatMessage((ChatMsg)info);
			}
			
			case Datum.CHAT_NAME_CHANGE:
			{
				chatClient.setChatMessage((ChatMsg)info);
				break;
			}
			
			case Datum.TITLE_CHANGE_REQUEST :
			{
				String title = (String)info;
				String cWord = "̸ " + title + "ٲڴ û Խϴ.";
				chatMsg = new ChatMsg("system",cWord);
				chatClient.setChatMessage(chatMsg);
				break;
			}
			
						
			case Datum.ROOM_TITLE_CHANGE :
			{
				String title = (String)info;
				chatClient.setRoomTitle(title);
				String cWord = "̸ " + title + "ٲپµ ɿ ó ?.";
				chatMsg = new ChatMsg("system",cWord);
				chatClient.setChatMessage(chatMsg);
				break;
			}
			
			case Datum.INVITE_SEND:
			{
				String buddy = (String)info;
				System.out.println(buddy + "  ʴ밡 Խϴ.Ͻðڽϱ ?");
				chatClient.receiveInvitation(buddy);
				// ޽ ̾α׸ .
				break;
			}
			case Datum.INVITE_ACCEPT:
			{
				String buddy = (String)info;
				String cWord = buddy + "  ʴ뿡 Ͽϴ. ȯ ݽô ! " ;
				chatMsg = new ChatMsg("system",cWord);
				chatClient.setChatMessage(chatMsg);
				chatClient.shareRoomName(buddy);
				break;
			}
			case Datum.INVITE_INFO:
			{
				String title = (String)info;
				System.out.println(title + "  մϴ.");
				chatClient.changeRoom(title);
				break;
			}
			case Datum.CHAT_MEMO:
			{
				ChatMsg chatMsg = (ChatMsg)info;
				String fromBuddy = chatMsg.getNick();
				System.out.println(fromBuddy + "   Խϴ.Ͻðڽϱ ?");
				chatClient.displayMemo(chatMsg);
				// ޽ ̾α׸ .
				break;
			}
			case Datum.FILE_TRANSFER:
			{
				String clientAddress = (String)info;
				System.out.println("clientAddress : " + clientAddress);
				chatClient.fileSend(clientAddress);
				// ޽ ̾α׸ .
				break;
			}
			case Datum.BUDDY_STATUS:
			{
				Vector buddyStatusV = (Vector)info;
				chatClient.setBuddyStatus(buddyStatusV);
				break;
			}
		}
	}
} /* end class ClientThread */
