import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

class FileSavingDialog extends JDialog implements ActionListener, WindowListener
{
	FileTransListener fileTransListener ;
	JFrame fileFrame;
	JTextField fileNameField;
	String fileName;
	String defaultDircetory = "c:\\temp\\";
	final static int FILE_WIDTH = 20;
	final int XLoc = 300;
	final int YLoc = 250;
	JFileChooser	saveFileChooser;
	
	public FileSavingDialog( String fileName,FileTransListener fileTransListener )
	{
		super(new JFrame(), "File saving Dialog", true);
		this.fileName = fileName;
		this.fileTransListener = fileTransListener;
		init();
	}
	
	void init()
	{
		msg("init");
		JLabel fileNameLabel = new JLabel("ȭ̸");
		fileNameField = new JTextField(defaultDircetory + fileName);
		JButton fileButton = new JButton("̸");
		JButton saveButton = new JButton("ȭϼ");
		JButton cancelButton = new JButton("Űź");
		
		fileButton.addActionListener(this);
		saveButton.addActionListener(this);
		cancelButton.addActionListener(this);

		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());

		JPanel centerPanel = new JPanel(new BorderLayout());
		JPanel southPanel = new JPanel(new FlowLayout());

		msg("init-add1");
		centerPanel.add(fileNameField);
		southPanel.add(fileButton);
		southPanel.add(saveButton);
		southPanel.add(cancelButton);
		msg("init-add2");
		
		msg("init-contentPane1");
		contentPane.add(centerPanel, BorderLayout.CENTER);
		contentPane.add(southPanel, BorderLayout.SOUTH);
		msg("init-contentPane2");
		
		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		setSize(300,100);
		setLocation(XLoc,YLoc);	
		setVisible(true);
	}
/*	
	public static void main(String args[])
	{
		FileSavingDialog fileSavingDialog = new FileSavingDialog("Datum.java");
		fileSavingDialog.init();
	}
*/	
	
	public void windowClosing(WindowEvent e) {
	}
	
	public void windowClosed(WindowEvent e) {
	
	}
	
	public void windowOpened(WindowEvent e) {
	}
	
	public void windowIconified(WindowEvent e) {
	}
	
	public void windowDeiconified(WindowEvent e) {
	}
	
	public void windowActivated(WindowEvent e) {
	}
	
	public void windowDeactivated(WindowEvent e) {
	}

	
	public void actionPerformed(ActionEvent aE)
	{
		String cmd = aE.getActionCommand();

		if (cmd.equals("̸"))
		{
			msg("̸");
			saveFileChooser = new JFileChooser(defaultDircetory);
			saveFileChooser.setSelectedFile(new File(fileName));
			int returnVal = saveFileChooser.showSaveDialog(new JFrame());
			if (returnVal == JFileChooser.APPROVE_OPTION)
			{
				File selectedFile = saveFileChooser.getSelectedFile();
				fileNameField.setText(selectedFile.getPath());
			}
		}
		

		else if (cmd.equals("ȭϼ"))
		{
			msg("ȭϼ");
			String fileName = fileNameField.getText();
			msg("fileName", fileName);
			File savingFile = new File(fileName);
			try
			{
				fileTransListener.fileTransfer(savingFile);
				dispose();
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
		
		else if (cmd.equals("Űź"))
		{
			try
			{			
				msg("Űź");
				fileTransListener.receiveAbort();
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
	}
	
	static int MSG_NO;
	String className =" FileSavingDialog   :   ";		
	
	void msg(String str)
	{
		System.out.println( ++MSG_NO + " @"+ className + str );
	}
	
	void msg(String str, int num)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + num );
	}
	
	void msg(String str, Object obj)
	{
		System.out.println( ++MSG_NO + " @"+ className + str + " --- " + obj );
	}	
	
	void msg(String str1, Object obj1,String str2, Object obj2)
	{
		System.out.println(  ++MSG_NO + " @" + className + str1 + " --- " + obj1 + "  ***  " + str2 +  " --- " + obj2 );
	}		
}
