import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

class LoginDialog extends JFrame implements ActionListener
{
	Client chatClient ;
	JTextField nickField;
	JTextField nameField;
	JTextField idField ;
	JTextField mailField;
	JTextField ageField;
	JComboBox sexCombo;
	
	public LoginDialog(ChatClient chatClient)
//	public LoginDialog(JFrame chatClient)
	{
		super(" ");
		this.chatClient = (Client)chatClient;
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		init();
		pack();
		setVisible(true);
	}
	
	void init()
	{
		JLabel nickLabel = new JLabel("");
		JLabel nameLabel = new JLabel("̸");
		JLabel idLabel = new JLabel("ID");
		JLabel mailLabel = new JLabel("E-Mail");
		JLabel ageLabel = new JLabel("");
		JLabel sexLabel = new JLabel("");
		
		JTextField nickField = new JTextField(20);
		JTextField nameField = new JTextField(20);
		JTextField idField = new JTextField(20);
		JTextField mailField = new JTextField(20);
		JTextField ageField = new JTextField(3);
		String[] sexChoice = {"",""};
		JComboBox sexCombo = new JComboBox(sexChoice);
		JButton sendButton = new JButton("");
		JButton cancelButton = new JButton("");

		sendButton.addActionListener(this);
		cancelButton.addActionListener(this);
		
		JPanel leftPanel = new JPanel();
		JPanel rightPanel = new JPanel();
		
		Container content = getContentPane();		
		content.add(leftPanel,BorderLayout.WEST);
		content.add(rightPanel,BorderLayout.CENTER);
		
		leftPanel.setLayout(new GridLayout(7,1));
		rightPanel.setLayout(new GridLayout(7,1));
		
		leftPanel.add(nickLabel);
		leftPanel.add(nameLabel);
		leftPanel.add(idLabel);
		leftPanel.add(mailLabel);
		leftPanel.add(ageLabel);
		leftPanel.add(sexLabel);
		leftPanel.add(cancelButton);
		

		rightPanel.add(nickField);
		rightPanel.add(nameField);
		rightPanel.add(idField);
		rightPanel.add(mailField);
		rightPanel.add(ageField);
		rightPanel.add(sexCombo);
		rightPanel.add(sendButton);
	}
	
	public void actionPerformed(ActionEvent aE)
	{
		String command = aE.getActionCommand();
		if (command.equals(""))
		{
			String nick = nickField.getText();
			String name = nameField.getText();
			String id = idField.getText();
			String mail = mailField.getText();
			String age = ageField.getText();
			String sex = (String)sexCombo.getSelectedItem();
			chatClient.register(nick,name,id,mail,age,sex);	
			dispose();
		}
		else
		{
			dispose();
		}
	}
/*	
	public static void main(String arg[])
	{
		new LoginDialog(new JFrame());
	}
*/
}

